/* A CGI-BIN  cookie-based customizer for OS/2 Web Servers
   Requires a web server that understands the NCSA-style #EXEC 
   server side includes.
   For example: 
       <!--  #Exec cmd="/cgi-bin/customiz?varname.setname -->
 
   CUSTCGI.CMD uses ".CC" files.  The easiest way to generate these
   files is with the MKCUSTCG.CMD  cgi-bin script.


                ------- IMPORTANT NOTE -------
                  You MUST set two parameters

    USERINFO_DIR
        USERINFO_DIR should point to the root of a storage directory --
        it's where the various "sets" of client customization
        files will be stored.
       ** THIS SHOULD BE THE SAME AS THE VALUE STORED IN MKCUSTCG.CMD **
              Example: userinfo_dir='d:\server\userinfo'

   SUPERUSER
      A space delimited list of numeric IP addresses -- client's with
      these IP addresses will be granted superuser privileges. Superuser's 
      are granted access to !variables, and are allowed to initialize 
      DEFAULT files.
            Example: superuser='127.51.511.2 '


          For further details, see CUST_CGI.HTM

*/

/********* BEGIN USER CHANGABLE CODE **********/

/* The directory containing the client-customization files */
userinfo_dir=$userinfodir

/* space delimited list of ip addresses granted superuser privileges */
superuser=$superuser




/********* BEGIN USER CHANGABLE CODE **********/


/*---   Load REXX libraries ----- */
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'

  call SysLoadFuncs
end


env = "OS2ENVIRONMENT"
len = value("CONTENT_LENGTH",,env)
method = translate(value("REQUEST_METHOD",,env))
if (method == "GET") Then Do
   avar= value("QUERY_STRING",,env)
end
globals.0=0
If (method == "POST") & (len \= "") Then Do
  avar = charin(,,len) /* read only the number specified in CONTENT_LENGTH */
End
/* no cookie info; give up */
if avar="" then do
  say ' ' 
  exit 0
end

USER=value("REMOTE_ADDR",,env)
privset=' '
if wordpos(user,superuser) then privset='SUPERUSER '



if pos('.',avar)=0 then do
   setname='DEFAULT' 
   varname=avar 
end;
else do ;
   parse var avar setname '.' varname 
end

/* !vars only for superusers */
if abbrev(varname,'!')=1 then do ;
  if wordpos('SUPERUSER',upper(privset))=0 then do  
       say ' '
       exit 0
  end  /* Do */
end 

varname=translate(varname)

/* determine client-info directory */

clidir=userinfo_dir

clidir=strip(clidir,'t','\')||'\'  ;
if setname<>'DEFAULT' then clidir=clidir||setname||'\' ;

/* find cookie */
cookval=translate(strip(get_cookie(setname))) ;

if cookval="" then  cookval=setname ;  /* no such cookie, use default */

chkf=clidir||cookval||'.CC' ;
cgot=sread(chkf)        /* read in chkf file and store values in GLOBALS.!CINFO */

if cgot=1 then do ;
    if symbol('GLOBALS.!CINFO.'||varname)='VAR' then do 
         say  globals.!cinfo.varname
         exit 0
    end ;
end ;

/* not found (no .cc file, or no varname in .cc file), try looking in default */
chkf=clidir||'DEFAULT.CC' ;
cgot=sread(chkf)
if cgot=1 then  do
    if symbol('GLOBALS.!cinfo.'||varname)='VAR'  then do
         say globals.!cinfo.varname
         exit 0
    end  /* Do */
end
say ' '         /* no default.cc, or no varname in default.cc */
exit 0


/********/
/* find a cookie */
get_cookie:procedure expose env
parse upper arg thecook,nth0
if nth0="" | nth0=0 then nth0=1

nth=0
aa=value('HTTP_COOKIE',,env)
do until aa=""
   parse var aa a1 ';' aa
   parse var a1 a1a '=' a1b ; a1a=strip(translate(a1a))
   if a1a=thecook then do 
        nth=nth+1
        if nth=nth0 then return a1b
   end  /* Do */
end /* do */
return ' '

/**************/
/* read .CC (afile) text file (that contains client prefernces), store in
   GLOBALS.!cinfo. stem */

sread:procedure expose globals.
parse arg afile

afile=stream(afile,'c','query exists')

if afile="" then return 0  /* no such file */

ndo=0
do forever
   if lines(AFILE)=0 then leave  /* done, return */
   ALINE=LINEIN(afile)
   if  abbrev(strip(aline),';')=1 then iterate
   parse var aline aname '=' aval ; aname=strip(translate(aname))  
   GLOBALS.!CINFO.ANAME=aval
   ndo=ndo+1
end /* do */
globals.0=ndo
if ndo=0 then return 0
return 1

