/* installation program for the CUSTOMIZ script for os/2 web servers*/

/* Load up advanced REXX functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

crlf='0d0a'x

ansion=checkansi()
if ansion=1 then do
  aesc='1B'x
  cy_ye=aesc||'[37;46;m'
  normal=aesc||'[0;m'
  bold=aesc||'[1;m'
  re_wh=aesc||'[31;47;m'
  reverse=aesc||'[7;m'
end
else do
  say " Warning: Could not detect ANSI....  Install will look ugly ! "
  parse pull .
  cy_ye="" ; normal="" ; bold="" ;re_wh="" ;
  reverse=""
end  /* Do */

cls
say  " " ; say

call lineout, bold cy_ye
call lineout, "This is the installation program for CUSTOMIZ (9/97).     "
call lineout, ' ... a CGI-BIN/#Exec "client customizaton" facility '
call lineout, normal

say " This program will ask for the names of a few directories,"
say " and will copy a number of files to these directories."
say "  "

if yesno(" Are you ready to continue ")=1 then
 nop
else do
 say " See you later?.. "
 exit
end


nowdir=directory()

godir=filespec('d',nowdir)||'\SERVER'
cgidir=filespec('d',nowdir)||'\SERVER\CGI-BIN'

webdir=filespec('d',godir)||'\WWW'


gunky2:
say " "
call charout,  bold " Enter your CGI-Bin directory (where CGI-BIN scripts are stored)? " normal crlf
call charout,"  ENTER= " cgidir  " ? "
parse pull cgi_dir
if cgi_dir="" then cgi_dir=cgidir
cgi_dir=strip(cgi_dir,'t','\')
foo=chkdir(cgi_dir)
if foo=0 then do
    say " Could not find directory: " cgi_dir
    signal gunky2
end


ii=lastpos('\',cgi_dir)
if ii=0 then do
    usrinf=godir||'\USERINFO'
end
else do
    usrinf=delstr(cgi_dir,ii+1)||'USERINFO'
end  /* Do */
gunky1:
say " "
call charout,  bold " Enter your USERINFO_DIR directory (for storing client info) " normal crlf
call charout,"  ENTER= " usrinf  " ? "
parse pull userinfo_dir
if userinfo_dir="" then userinfo_dir=usrinf
userinfo_dir=strip(userinfo_dir,'t','\')
foo=chkdir(userinfo_dir)
if foo=0 then do
    say " Could not find directory: " userinfo_dir
    signal gunky1
end

gunky3:
say " "
call charout,  bold " Enter the web document directory (that contains your home page)" normal crlf
call charout,"  ENTER= " webdir  " ? "
parse pull web_dir
if web_dir="" then web_Dir=webdir
web_dir=strip(web_dir,'t','\')
foo=chkdir(web_dir)
if foo=0 then do
    say " Could not find directory: " web_dir
    signal gunky3
end

custdir=web_dir||'\CUSTOM'
gunky4:
say " "
call charout,  bold " Enter the CUSTOM directory (must be under the web document directory)" normal crlf
call charout,"  ENTER= " custdir  " ? "
parse pull custom_dir
if custom_dir="" then custom_Dir=custdir
custom_dir=strip(custom_dir,'t','\')
foo=chkdir(custom_dir)
if foo=0 then do
    say " Creating " custom_dir
    wow=sysmkdir(custom_dir)
    if wow<>0 then do
      say " Could not create " custom_dir
       signal gunky3
    end
end
say " "

if yesno(" Are you ready to copy the files ")=0 then do
   say " Okay, you can try again later "
   exit
end  /* Do */
    
say " "
smpdir=userinfo_dir||'\SAMPLE'
if chkdir(smpdir)=0 then do
   say " Creating SAMPLE directory: " smpdir
   wow=sysmkdir(smpdir)
   if wow<>0 then do
        say " Could not create " smpdir
        say " Please create it, and re-run this install program "
   end
end

say
say " Copying CUSTOMIZ scripts "
foo=check_copy('CUSTCGI.CMD',cgi_dir)
foo=check_copy('MKCUSTCG.CMD',cgi_dir)
say " Copying html documents "
foo=check_copy('CUST_CGI.HTM',custom_dir)
foo=check_copy('CUST_CGJ.HTM',custom_dir)
say " Copying sample data file "
foo=check_copy('DEFAULT.CC',smpdir)

say
say 'Before using CUSTOMIZ, you ' bold 'must 'normal ' set a few parameters ' 
say 'in CUSTCGI.CMD and MKCUSTCG.CMD. These changes can be done now,'
say 'or you can do it later (using your favorite text editor). '
if yesno(' Modify parameters now? ')=1 then call domods



say " "
say reverse " ------------------------------------------------- "normal
say bold " The CUSTOMIZ files and directories have been created. " normal
say " "
say " For some further hints, see the READ.ME file "
say" "

exit

/* ------------------------------------------------------------------ */
/* domods: modify custcgi.cmd and mkcustcg.cmd */
domods:


f1=strip(cgi_dir,'t','\')||'\CUSTCGI.CMD'
f2=strip(cgi_dir,'t','\')||'\MKCUSTCG.CMD'

t1=charin(f1,1,chars(f1))
t2=charin(f2,1,chars(f2))

say '---------------------'
Say " Please enter a few parameter values "
say
call charout,' What is your hour offset from GMT (i.e.; 5 for EST): '
parse pull gmt_offset
if datatype(gmt_offset)<>'NUM' then gmt_offset=0

say
do queued(); pull .; end                   /* flush */
address cmd '@hostname | rxqueue'     /* execute the command */
parse pull hostresult                      /* get result */
address cmd '@host ' hostresult ' | rxqueue'     /* execute the command */
parse pull host2
say " Note: Your IP address = " host2
say ' Enter the numeric ' bold 'IP' normal ' address(es) of superusers '
call charout,' (a spaced delimited list): '
parse pull superuser

aq="'"

/* userinfo_dir and web_dir are already available */
t1=replacestrg(t1,'$USERINFODIR',aq||userinfo_dir||aq)
t1=replacestrg(t1,'$SUPERUSER',aq||superuser||aq)
a1=charout(f1,t1,1)
xx=stream(f1,'c','close')

t2=replacestrg(t2,'$USERINFODIR',aq||userinfo_dir||aq)
t2=replacestrg(t2,'$SUPERUSER',aq||superuser||aq)
t2=replacestrg(t2,'$GMTOFFSET',gmt_offset)
t2=replacestrg(t2,'$DATADIR',aq||web_dir||aq)
a1=charout(f2,t2,1)
xx=stream(f2,'c','close')


return 0


/* ------------------------------------------------------------------ */
 /* function: Check if ANSI is activated                               */
 /*                                                                    */
 /* call:     CheckAnsi                                                */
 /*                                                                    */
 /* where:    -                                                        */
 /*                                                                    */
 /* returns:  1 - ANSI support detected                                */
 /*           0 - no ANSI support available                            */
 /*          -1 - error detecting ansi                                 */
 /*                                                                    */
 /* note:     Tested with the German and the US version of OS/2 3.0    */
 /*                                                                    */
 /*                                                                    */
 CheckAnsi: PROCEDURE
   thisRC = -1
 
   trace off
                         /* install a local error handler              */
   SIGNAL ON ERROR Name InitAnsiEnd
 
   "@ANSI 2>NUL | rxqueue 2>NUL"
 
   thisRC = 0
 
   do while queued() <> 0
     queueLine = lineIN( "QUEUE:" )
     if pos( " on.", queueLine ) <> 0 | ,                       /* USA */
        pos( " (ON).", queueLine ) <> 0 then                    /* GER */
       thisRC = 1
   end /* do while queued() <> 0 */
 
 InitAnsiEnd:
 signal off error
 RETURN thisRC


/* -------------------- */
/* get a yes or no , return 1 if yes */
yesno:procedure expose normal reverse bold
parse arg fooa , allopt,altans
if altans<>" " & words(altans)>1 then do
   w1=strip(word(altans,1))
   w2=strip(word(altans,2))
   a1=left(w1,1) ; a2=left(w2,1)
   a1a=substr(w1,2) ; a2a=substr(w2,2)
end
else do
    a1='Y' ; a1a='es'
    a2='N' ; a2a='o'
end  /* Do */
ayn='  '||bold||a1||normal||a1a||'\'||bold||a2||normal||a2a
if allopt=1 then  ayn=ayn||'\'||bold||'A'||normal||'ll'

do forever
 foo1=normal||reverse||fooa||normal||ayn
 call charout,  foo1 normal ':'
 pull anans
 if abbrev(anans,a1)=1 then return 1
 if abbrev(anans,a2)=1 then return 0
 if allopt=1 & abbrev(anans,'A')=1 then return 2
end


/* ------------- */
/* ----------------------------------------------------------------------- */
/* REPLACESTRG: In string astring, find first occurence substring target and
.   replace it with substring putme
.      if no target, return unchanged astring
.      if no putme, then remove target
.      if type=backward, then find/change LAST occurence
.      if type=all, find/change all occurences
.      if exactmatch=yes, then do not capitalize during search (exact match only */
/* ----------------------------------------------------------------------- */

replacestrg: procedure

exactmatch=0
backward=0 ; doall=0

parse arg astring ,  target   , putme , type , exactmatch

type = translate(type)
if type="BACKWARD" then backward="YES"
if type="ALL" then doall="YES"

iat=1
joelen=length(target)
joelen2=length(putme)

doagain:                /* here if doall=yes */
 if exactmatch="YES" then do
    if   backward="YES" then
        joe= lastpos(target,astring)
    else
        joe= pos(target,astring,iat)
 end
 else do
   if   backward="YES" then
        joe= lastpos(translate(target),translate(astring))
    else
        joe= pos(translate(target),translate(astring),iat)
 end
 if joe=0 then
         return astring

 astring=delstr(astring,joe,joelen)
 if putme<>' ' then
    astring=insert(putme,astring,joe-1)

 if doall="YES" then do
     iat=joe+joelen2
     signal doagain
 end
/* else, all done */
 return astring

/*******************************************/
/* check for existence of file, then ask user to copy or not */
/* note that for X.* type copies, it only checks once
   (not for each file, but just for any one of them */
/********************************************/
check_copy: procedure expose copyall reverse bold normal
parse arg file1, dest1 , amess , noask

dest2=strip(dest1,'t','\')||'\'

filename=dest2||file1


if copyall=1 then signal doit3


aa=sysfiletree(filename,isit,'F')

ok=1
if aa<>0 then do
   say " Warning: error when looking for pre-existing copy of: " filename
   ok=yesno(" Do you want to copy this file (or files) anyways? ")
   if ok=1 & amess<>""  then
      ok=yesno(amess)
end

if noask=1 then signal doit3

if isit.0>0 then do
  if pos('*',file1)=0 then do
      say " "
      say " A file exists with the name: " filename
      ok=yesno(" Do you want to overwrite this file? ",1)
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end
  else do
    say " "
      say " There is at least one file that matches: " filename
      say "  (this match may " bold " not " normal " be one of the files that will be copied!) "
      ok=yesno(" Do you want to copy these files? ",1)
      if ok=1 & amess<>""  then
           ok=yesno(amess)
  end  /* Do */

end

if ok=2 then do
  say " "
  say "Overwrite all files (not just these) "
  copyall=yesno(" Are you sure you want to do this?")
  if copyall=0 then
      ok=yesno(" Do you want to overwrite the current file (or files)? ")
end

if ok=0  then return 0

doit3:          /* jump here if copyall is on, or noask=1 */
'@COPY ' file1 dest1 ' > NUL '

return 1



/*****/
chkdir:procedure
parse upper arg ab
aa=directory()
bb=directory(ab)
oo=directory(aa)
if ab=translate(bb) then return 1
return 0

