/* MkCustcg -- the cgi-bin "save client preferences" 
 
   This is used to create client customization (.CC) files
   in subdirectories under the USERINFO_DIR. 
   MKCUSTCG should be called as a cgi-bin script, typically using
   an HTML form.
   MKCUSTCG will extract parameters sent by the form, and will then
   create "client customizaton" (CC) files.
   These .CC files are used to insert client preferences into
   an html document (by using CUSTCGI.CMD as and "#EXEC"  server side
   include, which requires a server that understands NCSA-style server 
   side includes)


                ------- IMPORTANT NOTE -------
                   You MUST set several variables:
  USERINFO_DIR:
      USERINFO_DIR should point to the root of a storage directory --
      it's where the various "sets" of client customization
      files will be stored.
       ** THIS SHOULD BE THE SAME AS THE VALUE STORED IN CUSTCGI.CMD **
           Example: USERINFO_DIR='D:\SERVER\USERINFO'

  GMT_OFFSET
      # hours offset from GMT (used in setting expiration date).
      For example, EST=5.
      If you do not set this, your expirations will be a little bit off.
           Example: GMT_OFFSET=5

  DATA_DIR
      Root of your html document directory tree. This is used when
      resolving response files with relative names (i.e.; CUSTOM\RESP1.HTM).
      Note that this "root" directory should be the directory used
      when requests of the form "http://www.your.net/file.ext" are
      recieved.
            Example:  data_dir='D:\WWW'

   SUPERUSER
      A space delimited list of numeric IP addresses -- client's with
      these IP addresses will be granted superuser privileges. Superuser's 
      are granted access to !variables, and are allowed to initialize 
      DEFAULT files.
            Example: superuser='127.51.511.2 '
 
             For further details, see CUST_CGI.HTM

*/

mkcustcg:


/********* BEGIN USER CHANGABLE CODE **********/


/* The directory containing the client-customization files */
userinfo_dir=$userinfodir

/* # hours offset from GMT (EST=5) */
gmt_offset=$gmtoffset

/* Root directory for your HTML documents */
data_dir=$datadir

/* Numeric IP addresses of superusers (space delimited list)*/
superuser=$superuser



/*********  END USER CHANGABLE CODE **********/
Parse Arg Argv

signal on error name foo1 ; signal on syntax name foo1 ;


/*---   Load REXX libraries ----- */
/* Load up advanced REXX functions */
foo=rxfuncquery('sysloadfuncs')
if foo=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'

  call SysLoadFuncs
end


env = "OS2ENVIRONMENT"
len = value("CONTENT_LENGTH",,env)
method = translate(value("REQUEST_METHOD",,env))
if (method == "GET") Then Do
   list= value("QUERY_STRING",,env)
end
varset.0=0
If (method == "POST") & (len \= "") Then Do
  list = charin(,,len) /* read only the number specified in CONTENT_LENGTH */
End
USER=value("REMOTE_ADDR",,env)

privset=' '
if wordpos(user,superuser) then privset='SUPERUSER '


list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */


init=0 ; vars.0=0 ;
password=' ' ; nodelete=0 ;
setname="DEFAULT" ;
identifier=0 ;
response=0 ;
expire="" ;
path="/" ;
nvars=0; invars=0
do ll=1 to 100 ; initvars.ll='' ; end;
VARSET.2000=' '
data_dir=strip(data_dir)
if data_dir<>' ' then data_dir=strip(data_dir,'t','\')


/* parse out args */
do until list=""
 parse var list a1 '&' list
 parse var a1 avar '=' aval
 aval=packur2(aval) ; avar=translate(strip(avar))

 taval=strip(translate(aval))
 select
    when avar="SETNAME" then setname=taval
    when avar="IDENTIFIER" then identifier=taval
    when avar="PASSWORD" then password=taval
    when avar="NODELETE" then nodelete=taval
    when avar="RESPONSE" then response=aval
    when avar="EXPIRE" then expire=taval
    when avar="PATH" then path=taval
    when avar="INIT" then init=taval
    when abbrev(avar,'VAR.')=1 then do
          parse var avar . '.' vname 
          if vname="" then iterate
          if datatype(vname)='NUM' then do
               if vname<100 then do
                    initvars.vname=strip(translate(aval))
                    if initvars.vname<>' ' & initvars.vname<>0 then invars=invars+1
                    iterate
               end  /* Do */
               if vname>100 then do
                     jj=vname-100
                     initvars.!val.jj=aval
                     iterate
               end  /* Do */
          end  /* initvar special case */
          nvars=nvars+1
          vars.!name.nvars=vname
          vars.!val.nvars=aval
    end
    otherwise nop
 end  /* select */
end /* do */

/* cleanup values */
if response=' ' then response=0
if identifier=0 | identifier="" then do
     identifier=0
     password="" ; nodelete=1
end  /* Do */
if wordpos(init,'Y 1 YES')>0 then do 
    if privset<>'SUPERUSER' then foo=is_error(' initialization requires superuser privileges ')
    init=1 ; expire=0
    response=0
    identifier='DEFAULT'
end  /* Do */
if password<>""  then nodelete=0
if wordpos(nodelete,'Y 1 YES')>0 then nodelete=1
if datatype(expire)<>'NUM' then expire=' '

if response<>0 then do
    response=strip(packur2(response))
   if abbrev(response,'\')=1 | pos(':',response)>0 then do
        nop
    end  /* Do */
    else do
        if data_dir<>' ' then response=data_dir||'\'||response
    end  /* Do */
end  /* Do */

if invars+nvars=0 then do
   call is_error(' No variables specified ')
end  /* Do */


/* specify the DIR */
adir=userinfo_dir
adir=strip(adir,'t','\')
if setname<>"DEFAULT" & setname<>0 & SETNAME<>"" then adir=adir||'\'||setname
if chkdir(adir)<>1 then do
    if init=1 then do
          foo=sysmkdir(adir)
          if foo<>0 then do
            call is_error(' Unable to initialize directory: '||adir)
           end  /* Do */
    end  /* Do */
    else do
       call is_error(' Unable to create client preferences file for '||setname)
    end
end  /* Do */


/* DOES FILE EXIST */
IF IDENTIFIER=0 | IDENTIFIER="" then do
    aIDENTIFIER='C?????.CC'
end
ELSE do
    aIDENTIFIER=IDENTIFIER||'.CC'
end
fname=adir||'\'||aIDENTIFIER
if pos('?',fname)>0 then do
   FNAME=systempfilename(fname)

   if fname=' ' then do
        foo=is_error( ' Can not create file, even with wildcards. ')
   end /* do */
   else

   jj=lastpos('\',fname)
   ide=substr(fname,jj+1)
   parse var ide identifier '.' .
end

isf=stream(fname,'c','query exists')

/* file exists: can we modify it */
if isf<>"" & nodelete=1 & init=0 then do     /* overwrite not allowed */
     call is_error(' Can not create/modify preferences file: name is being used (try a different name) ')
end  /* Do */
/* note: if init=1, just overwrite default.cC */

drop varset.
VARSET.2000=' '

/* if init=1, then write the varnames, and return */
if init=1  then do
   do jj=1 to 100
      if initvars.jj=' ' then iterate
      am=translate(initvars.jj)
/* prevent overwrite of reserved words */
      if wordpos(am,'!NODELETE !PASSWORD !CREATION !WHO !IDENTIFIER ')>0 then iterate
      if datatype(am)='NUM' then iterate
      varset.am=initvars.!val.jj
      VARSET.2000=VARSET.2000||' '||AM
   end /* do */
   varset.!creation=time('N')||' '||date('n')
   varset.!who=user
   varset.!identifier=identifier
   varset.!nodelete=1
   varset.!password=' '
   varset.!expire=' '
   varset.!path=' '
   varset.2000=VARSET.2000||' !CREATION !WHO !IDENTIFIER !NODELETE !PASSWORD !EXPIRE !PATH '
   aa=swrite(fname)
   if aa=0 then do
        call is_error(' Could not write Default.CC ')
   end
   else do
        foo=is_success(' Initialized: ' fname ' with ' invars ' variables',response)
   end
end

/* not init.
 If file does not exist, then add variables and add them; possbly add
  PASSWORD and NODELETE flags.
 If does exist, then perhaps append them -- but first check NODELETE (creation)
 and PASSWORD conditions */


 if isf<>' ' then do    /* file exists; can we modify it? */
       oo=sread(isf)
       if symbol('varset.!Nodelete')='VAR' then do
         if  varset.!Nodelete=1  then do
             call is_error(' Not allowed to modify preferences file ')
          end  /* Do */
       end
       if symbol('VARSET.!PASSWORD')='VAR' then do
          if varset.!password<>password then do
              call is_error(' Incorrect password, not allowed to modify preferences file ')
          end
       end
  end

/* add variables to varset (possibly empty ) */
  do mm=1 to nvars
     av=vars.!name.mm
     varset.av=vars.!Val.mm
     varset.2000=varset.2000||' '||av
  end
 if password<>' ' then varset.!password=password
 varset.!nodelete=nodelete
 varset.!creation=time('N')||' '||date('n')
 varset.!who=user
 varset.!identifier=identifier
 varset.!password=password
 varset.!expire=expire
 if expire<>' ' & expire<>0 then varset.!expire=cookie_date(expire)
 varset.!path=path
 varset.2000=VARSET.2000||' !CREATION !WHO !IDENTIFIER !NODELETE !PASSWORD !EXPIRE !PATH '

 aa=swrite(fname)

 if aa=0 then do
        call is_error(' Could not write preferences... ')
  end
  else do
        foo=is_success(' Your preferences have been saved.',response)
  end


/*******/
is_error:
parse arg amess

  Say "Content-type: text/html"
  say 
  say '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
  say  "<html><head><title>Client customization error</title>"
  say "</head><body>"
  say ' <h2>Client customization error</h2>'
  say amess
  say ' </body></html>'

  exit 0



/*******/
is_success:procedure expose tempfile identifier setname expire path servername gmt_offset
parse arg amess,response


if response=' ' then response=0
  Say "Content-type: text/html"
 if expire<>0 | expire="" then do
     a1=setname'='identifier
     a2=' '; if expire<>' ' then a2=' ; expires='||cookie_date(expire)
     a3=' ; PATH='path
     Say ' Set-Cookie: '||a1||a2||a3
 end
 Say

stp1:nop

  if response=0 | response=' ' then do
     say '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
     say "<html><head><title>Client customization</title>"
     say "</head><body>"
     say' <h2>Client customization</h2>'
     say 'Your preferences have been saved. '
     say' </body></html>'
     exit 0
  end

 uu=translate(strip(response))
  if abbrev(uu,'HTTP://')=1 then do
     say '<!doctype html public "-//IETF//DTD HTML 2.0//EN">'
     say "<html><head><title>Client customization</title>"
     say "</head><body>"
     say' <h2>Client customization</h2>'
     say 'Your preferences have been saved. <BR>'
     say' <BR> Examine <a href="'||response||'">'||response||'</a>? '
     say' </body></html>'
     exit 0
  end

   response=stream(response,'c','query exists')
   if response=" " then signal stp1

/* send response file */
    do forever
       if lines(response)=0 then exit 0
       aa=linein(response)
       say aa
    end /* do */

     exit 0     /* should never get here */


/**************/
/* read .CC (afile) text file (that contains client prefernces), store in
   varset. stem */

sread:procedure expose varset.
parse arg afile

afile=stream(afile,'c','query exists')

if afile="" then return 0  /* no such file */
varset.2000=' '
ndo=0
do forever
   if lines(AFILE)=0 then leave  /* done, return */
   ALINE=LINEIN(afile)
   if  abbrev(strip(aline),';')=1 then iterate
   parse var aline aname '=' aval ; aname=strip(translate(aname))  
   varset.ANAME=aval
   varset.2000=varset.2000||' '||aname
   ndo=ndo+1
end /* do */
varset.0=ndo
if ndo=0 then return 0
return 1


/*************/
/* write stem vars to file -- overwrite it's there */
swrite:procedure expose varset.
PARSE ARG AFILE
varlist=varset.2000
ll=stream(afile,'c','query exists')
IF ll<>"" then do
  foo=sysfiledelete(afile)
  if foo<>0 then return 0
end
do mm=1 to words(varlist)
    aw=strip(upper(word(varlist,mm)))
    AVAL=VARSET.AW
    call lineout afile,aw'='aval
end /* do */
call lineout afile
IF STREAM(AFILE,'c','query exists')="" then return 0
return 1


/*****/
chkdir:procedure
parse upper arg ab
aa=directory()
bb=directory(ab)
oo=directory(aa)
if ab=translate(bb) then return 1
return 0




/* procedure from TEST-CGI.CMD by  Frankie Fan <kfan@netcom.com>  7/11/94 */
packur2: procedure
  parse arg Code
  Text=''
  Code=translate(Code, ' ', '+')
  rest='%'
  do while (rest\='')
     Parse var Code T '%' rest
     Text=Text || T
     if (rest\='') then
      do
        ch = left( rest,2)
        c=X2C(ch)
        Text=Text || c
        Code=substr( rest, 3)
      end
  end
  return Text




/***************************************************************/
/* the following is  a date function.
   It's too big, but it does work... */


/***********************
Return gmt time in cookie format.
Requires GMT_OFFSET global.
Will optionally add an offset (in days, fractions allowed)

using code adapted from datergf (available on hobbes.nmsu.edu)
author:  Rony G. Flatscher,
         Wirtschaftsuniversitt/Vienna
         Rony.Flatscher@wu-wien.ac.at

*/
cookie_date:procedure expose gmt_offset
parse arg addme
if addme=" " | datatype(addme)<>'NUM' then addme=0
numeric digits 12
a1=date('s')
yow=dodate(date('s')' 'time('n'))
yow2=yow+addme
if datatype(gmt_offset)='NUM' then
    yow2=yow2+(gmt_offset/24)
yow3=dodate(yow2,'S')
parse var yow3 dd tt
aday=left(dodate(yow3,'DN'),3)

amm=left(dodate(yow3,'MN'),3)
ayr=left(dd,4)
ady=right(dd,2)

return aday',' ady'-'amm'-'ayr tt ' GMT'


/***************************/
/* the guts of datergf */

dodate:procedure
parse arg addme

DO
    argument1 = ARG(1)
    argument2 = ARG(2)
    argument3 = ARG(3)
    argcount  = ARG()      /* number of arguments */
END


NUMERIC DIGITS 14          /* set precision to 14 digits after comma */

PARSE UPPER VAR argument1 date1 time1
flag = TRANSLATE(argument2)
PARSE UPPER VAR argument3 date2 time2

/* build monthdays array */
monthdays.1 = 31
monthdays.2 = 28
monthdays.3 = 31
monthdays.4 = 30
monthdays.5 = 31
monthdays.6 = 30
monthdays.7 = 31
monthdays.8 = 31
monthdays.9 = 30
monthdays.10 = 31
monthdays.11 = 30
monthdays.12 = 31


/* check sorted dates & numbers */

IF argument3 <> '' & flag <> '-S' THEN     /* check whether third argument is a valid number */
   IF \DATATYPE(argument3, 'N') THEN
   DO
      errmsg = argument3': not numeric'
      SIGNAL error
   END

SELECT
   /* check sorted date and adjust monthdays. array, if necessary */
   WHEN WORDPOS(flag, "S SEC SECR JR F FR") = 0 | flag = '' THEN
        DO
           date1 = check_date(date1)
           IF time1 <> '' THEN time1 = check_time(time1)
        END

   WHEN flag = 'F' THEN time1 = check_time(date1)       /* time in hand ? */

   OTHERWISE    /* argument1 a positive number ? */
        DO
           IF \DATATYPE(argument1,'N') THEN
           DO
              errmsg = argument1': not numeric'
              SIGNAL error
           END
           ELSE IF argument1 < 0 THEN
           DO
              errmsg = argument1': must be a positive number'
              SIGNAL error
           END
        END
END


/* act according to flag */
SELECT
   WHEN flag = '' THEN                  /* SDATE: calculate days of date = DAYS */
        DO
           days1 = date2days(date1)
           if time1 <> '' THEN fraction1 = time2fract(time1)
                          ELSE fraction1 = ''
           result_datergf = days1||SUBSTR(fraction1,2)
        END

   WHEN flag = 'S' THEN                 /* DAY: calculate date/time = SDATE */
        DO
          IF date1 < 1 THEN
          DO
                errmsg = argument1 argument2": yields invalid date (< 0000/01/01) !"
                SIGNAL error
          END

          days_int = date1 % 1
          IF days_int > 3652427 THEN    /* > 9999/12/31 ? */
          DO
                errmsg = argument1 argument2": yields invalid date (> 9999/12/31) !"
                SIGNAL error
          END

          time_only = date1 - days_int
          date = days2date(days_int)      /* get rid of fraction */

          IF time_only > 0 THEN date = date fract2time(time_only)

          result_datergf = date
        END

   WHEN flag = '-S' THEN                /* SDATE - SDATE = DAYS */
        DO
           days1 = date2days(date1)
           IF time1 <> '' THEN fraction1 = time2fract(time1)
                          ELSE fraction1 = ''
           result_datergf1 = days1||SUBSTR(fraction1,2)

           /* check date2 and prepare monthdays. */
           date2 = check_date(date2)
           days2 = date2days(date2)

           IF time2 <> '' THEN fraction2 = time2fract(check_time(time2))
           ELSE fraction2 = ''

           result_datergf2 = days2||SUBSTR(fraction2,2)
           result_datergf = result_datergf1 - result_datergf2
        END

   WHEN (flag = '-') | (flag = '+') THEN        /* SDATE-DAYS = SDATE */
        DO
          days1 = date2days(date1)

          IF time1 <> '' THEN fraction1 = time2fract(time1)
                         ELSE fraction1 = ''

          temp = days1||SUBSTR(fraction1,2)

          IF flag = '-' THEN
             temp = temp - date2           /* subtract */
          ELSE
             temp = temp + date2           /* add */

          IF temp < 1 | ABS(temp) > 3652427 THEN        /* < 0000/01/01 or > 9999/12/31 ? */
          DO
               errmsg = argument1 argument2 argument3": does not yield a valid date!"
               SIGNAL error
          END

          days1 = temp % 1                  /* days since 0000/01/01 inclusive == 1 */
          time1 = temp // 1                 /* time */
          result_datergf = days2date(days1)

          IF time1 > 0 THEN
             result_datergf = result_datergf fract2time(time1)
        END

   WHEN flag = 'J' THEN                 /* SDATE = JDATE */
        result_datergf = date2julian(date1)

   WHEN flag = 'JR' THEN                /* JDATE = SDATE (reverse Julian date) */
        result_datergf = julian2date(date1)

   WHEN flag = 'F' THEN                 /* generate FRACT from TIME */
        result_datergf = time2fract(time1)

   WHEN flag = 'FR' THEN                /* generate TIME24 from decimal fraction */
        result_datergf = fract2time(date1 // 1)

   WHEN flag = 'SEC' THEN               /* generate SECONDS from DAYS[.FRACTION] */
        result_datergf = (date1 * 86400 + 0.5) % 1  /* round to seconds */

   WHEN flag = 'SECR' THEN              /* generate DAYS[.FRACTION] from SECONDS */
        result_datergf = date1 / 86400

   WHEN flag = 'C' THEN                 /* check date[ time] */
        result_datergf = argument1

   WHEN flag = 'L' THEN                 /* is date in a leap year? */
        DO
           year = WORD(date1, 1)
           IF year > 1582 THEN             /* Gregorian calender */
              result_datergf = (((year // 4) = 0) & \((year // 100) = 0)) | ((year // 400)=0)
           ELSE result_datergf = ((year // 4) = 0) /* Julian calender    */
        END

   WHEN flag = 'Y' THEN                 /* return year */
        result_datergf = WORD(date1, 1)

   WHEN flag = 'YB' | flag = 'YE' THEN     /* return year-begin or -end  */
        DO
           year = WORD(date1, 1)           /* optionally add (negative) days */

           IF argcount < 3 THEN               /* no third argument */
           DO
              IF flag = 'YB' THEN result_datergf = year||'0101'
              ELSE result_datergf = year||'1231'

              IF time1 <> '' THEN result_datergf = result_datergf TRANSLATE(time1,':',' ')
           END
           ELSE
           DO
              IF flag = 'YB' THEN result_datergf = year '1 1'
              ELSE result_datergf = year '12 31'

              result_datergf = date2days(result_datergf)
              IF time1 <> '' THEN result_datergf = result_datergf + time2fract(time1)
              result_datergf = result_datergf + date2

              days = result_datergf % 1
              IF days < 1 | ABS(days) > 3652427 THEN    /* < 0000/01/01 or > 9999/12/31 ? */
              DO
                   errmsg = argument1 argument2 argument3": does not yield a valid date!"
                   SIGNAL error
              END

              fraction = result_datergf // 1
              result_datergf = days2date(days)
              IF fraction > 0 THEN result_datergf = result_datergf fract2time(fraction)
           END
        END

   WHEN flag = 'M' THEN                 /* return month */
        result_datergf = WORD(date1, 2)

   WHEN flag = 'MN' THEN                /* return monthname */
        result_datergf = WORD("January February March April May June July",
                 "August September October November December", WORD(date1, 2))

   WHEN flag = 'MB' | flag = 'ME' THEN     /* return month-begin or -end  */
        DO
           PARSE VAR date1 year month .    /* optionally add (negative) days */

           IF argcount < 3 THEN               /* no third argument */
           DO
              IF flag = 'MB' THEN result_datergf = year||RIGHT(month,2,'0')||'01'
              ELSE IF year = 1582 & month = 10 THEN result_datergf = year||RIGHT(month,2,'0')||'31'
              ELSE result_datergf = year||RIGHT(month,2,'0')||monthdays.month

              IF time1 <> '' THEN result_datergf = result_datergf TRANSLATE(time1,':',' ')
           END
           ELSE
           DO
              IF flag = 'MB' THEN result_datergf = year month '1'
              ELSE IF year = 1582 & month = 10 THEN result_datergf = year month '31'
              ELSE result_datergf = year month monthdays.month

              result_datergf = date2days(result_datergf)
              IF time1 <> '' THEN result_datergf = result_datergf + time2fract(time1)
              result_datergf = result_datergf + date2

              days = result_datergf % 1
              IF days < 1 | ABS(days) > 3652427 THEN    /* < 0000/01/01 or > 9999/12/31 ? */
              DO
                   errmsg = argument1 argument2 argument3": does not yield a valid date!"
                   SIGNAL error
              END

              fraction = result_datergf // 1
              result_datergf = days2date(days)
              IF fraction > 0 THEN result_datergf = result_datergf fract2time(fraction)
           END
        END


   WHEN flag = 'W' THEN                 /* calculate week of year */
        DO
          PARSE VAR date1 year month day

          PARSE VALUE weekday(year "1 1", "ALL") WITH days_a d_ia

          /* 1. week or old year's week ? */
          IF d_ia > 4 THEN diff = d_ia - 9
          ELSE diff = d_ia - 2

          c1 = SUBSTR(date2julian(date1),5,3) + diff
          result_datergf = c1 % 7 + 1           /* number of weeks */

          IF result_datergf > 51 THEN           /* last week in year ?, probably 1st week? */
          DO

             PARSE VALUE weekday(year "12 31", "ALL") WITH days_0 di0

             IF di0 < 4 THEN
                IF day > (31-di0) THEN result_datergf = 1 /* first week, as 31st smaller than thursday  */
          END
          ELSE IF result_datergf = 1 THEN       /* beginning of January, is it last year's last week ? */
          DO
             IF (day + diff) < 0 THEN
             DO
                PARSE VALUE weekday(RIGHT(year-1,4,'0') "1 1", "ALL") WITH days_0 di0

                IF di0 > 4 THEN diff2 = di0 - 9 /* second week is first */
                ELSE diff2 = di0 - 2            /* first week */

                c1 = SUBSTR(date2julian((RIGHT(year-1,4,'0') "12 31")),5,3) + diff2
                result_datergf  = c1 % 7 + 1            /* number of weeks */
             END
          END
        END

   WHEN flag = 'D' THEN                 /* return day */
        result_datergf = WORD(date1, 3)

   WHEN flag = 'DN' THEN                /* return dayname */
        result_datergf = weekday(date1)

   WHEN flag = 'DI' THEN               /* return dayindex */
        result_datergf = weekday(date1, "I")

   WHEN flag = 'WB' | flag = 'WE' THEN     /* return week-begin (MON) or -end (SUN)  */
        DO
           PARSE VALUE weekday(date1, "ALL") WITH tmp di

           IF flag = 'WB' THEN diff = 1 - di
           ELSE diff = 7 - di

           new_days = tmp + diff

           IF argcount < 3 THEN               /* no third argument */
           DO
              IF new_days < 1 THEN         /* 0000/01/01 = THU, no monday available */
              DO
                   errmsg = argument1 argument2": does not yield a valid date!"
                   SIGNAL error
              END
              result_datergf = days2date(new_days)
              IF time1 <> '' THEN result_datergf = result_datergf TRANSLATE(time1,':',' ')
           END
           ELSE
           DO
              IF time1 <> '' THEN result_datergf = new_days + time2fract(time1)
              ELSE result_datergf = new_days

              result_datergf = result_datergf + date2

              days = result_datergf % 1
              IF days < 1 | ABS(days) > 3652427 THEN    /* < 0000/01/01 or > 9999/12/31 ? */
              DO
                   errmsg = argument1 argument2 argument3": does not yield a valid date!"
                   SIGNAL error
              END

              fraction = result_datergf // 1
              result_datergf = days2date(days)
              IF fraction > 0 THEN result_datergf = result_datergf fract2time(fraction)
           END
        END


   WHEN flag = 'Q' THEN                 /* return quarter */
        DO
           year = WORD(date1, 1)
           tmp = WORD(argument1, 1)           /* sorted date */
           SELECT
              WHEN tmp < year||'0401' THEN result_datergf = 1
              WHEN tmp < year||'0701' THEN result_datergf = 2
              WHEN tmp < year||'1001' THEN result_datergf = 3
              OTHERWISE result_datergf = 4
           END
        END

   WHEN flag = 'QB' | flag = 'QE' THEN  /* return quarter-begin or -end  */
        DO                              /* optionally add (negative) days */
           year = WORD(date1, 1)
           tmp = WORD(argument1, 1)        /* sorted date */

           IF argcount < 3 THEN            /* no third argument */
           DO
              IF flag = 'QB' THEN       /* quarter begin */
              DO
                 SELECT
                    WHEN tmp < year||'0401' THEN result_datergf = year||'0101'
                    WHEN tmp < year||'0701' THEN result_datergf = year||'0401'
                    WHEN tmp < year||'1001' THEN result_datergf = year||'0701'
                    OTHERWISE result_datergf = year||'1001'
                 END
              END
              ELSE                      /* quarter end */
              DO
                 SELECT
                    WHEN tmp < year||'0401' THEN result_datergf = year||'0331'
                    WHEN tmp < year||'0701' THEN result_datergf = year||'0630'
                    WHEN tmp < year||'1001' THEN result_datergf = year||'0930'
                    OTHERWISE result_datergf = year||'1231'
                 END
              END

              IF time1 <> '' THEN result_datergf = result_datergf TRANSLATE(time1,':',' ')
           END
           ELSE
           DO
              IF flag = 'QB' THEN
              DO
                 SELECT
                    WHEN tmp < year||'0401' THEN result_datergf = year  '1 1'
                    WHEN tmp < year||'0701' THEN result_datergf = year  '4 1'
                    WHEN tmp < year||'1001' THEN result_datergf = year  '7 1'
                    OTHERWISE result_datergf = year  '10 1'
                 END
              END
              ELSE
              DO
                 SELECT
                    WHEN tmp < year||'0401' THEN result_datergf = year  '3 31'
                    WHEN tmp < year||'0701' THEN result_datergf = year  '6 30'
                    WHEN tmp < year||'1001' THEN result_datergf = year  '9 30'
                    OTHERWISE result_datergf = year  '12 31'
                 END
              END

              result_datergf = date2days(result_datergf)
              IF time1 <> '' THEN result_datergf = result_datergf + time2fract(time1)
              result_datergf = result_datergf + date2

              days = result_datergf % 1
              IF days < 1 | ABS(days) > 3652427 THEN    /* < 0000/01/01 or > 9999/12/31 ? */
              DO
                   errmsg = argument1 argument2 argument3": does not yield a valid date!"
                   SIGNAL error
              END

              fraction = result_datergf // 1
              result_datergf = days2date(days)
              IF fraction > 0 THEN result_datergf = result_datergf fract2time(fraction)
           END
        END

   WHEN flag = 'HY' THEN                /* return semester (1 = 1.half, 2 = 2.half */
           IF WORD(date1, 2) < 7 THEN result_datergf = 1
           ELSE result_datergf = 2

   WHEN flag = 'HYB' | flag = 'HYE' THEN   /* return quarter-begin or -end  */
        DO
           PARSE VAR date1 year month .    /* optionally add (negative) days */

           IF argcount < 3 THEN               /* no third argument */
           DO
              IF flag = 'HYB' THEN
              DO
                 IF month < 7 THEN result_datergf = year||'0101'
                 ELSE result_datergf = year||'0701'
              END
              ELSE
              DO
                 IF month < 7 THEN result_datergf = year||'0630'
                 ELSE result_datergf = year||'1231'
              END

              IF time1 <> '' THEN result_datergf = result_datergf TRANSLATE(time1,':',' ')
           END
           ELSE
           DO
              IF flag = 'HYB' THEN
              DO
                 IF month < 7 THEN result_datergf = year '1 1'
                 ELSE result_datergf = year '7 1'
              END
              ELSE
              DO
                 IF month < 7 THEN result_datergf = year  '6 30'
                 ELSE result_datergf = year '12 31'
              END

              result_datergf = date2days(result_datergf)
              IF time1 <> '' THEN result_datergf = result_datergf + time2fract(time1)
              result_datergf = result_datergf + date2

              days = result_datergf % 1
              IF days < 1 | ABS(days) > 3652427 THEN    /* < 0000/01/01 or > 9999/12/31 ? */
              DO
                   errmsg = argument1 argument2 argument3": does not yield a valid date!"
                   SIGNAL error
              END

              fraction = result_datergf // 1
              result_datergf = days2date(days)
              IF fraction > 0 THEN result_datergf = result_datergf fract2time(fraction)
           END
        END

   OTHERWISE
        DO
          errmsg = flag': unknown flag'
          SIGNAL error
        END
END

RETURN result_datergf         /* return value */

/* end of main routine */






/* parse & check arguments */
CHECK_DATE: PROCEDURE EXPOSE monthdays. flag
    PARSE ARG 1 year 5 month 7 day 9

    IF \DATATYPE(year,'N') THEN
    DO
       errmsg = ARG(1)": year is not numeric"
       SIGNAL error
    END

    IF year < 0 THEN
    DO
       errmsg = ARG(1)": year must be 0000 or greater"
       SIGNAL error
    END

    /* is year a leap year ? */
    IF year > 1582 THEN                 /* Gregorian calender */
       leap_year = (((year // 4) = 0) & \((year // 100) = 0)) | ((year // 400)=0)
    ELSE leap_year = ((year // 4) = 0)  /* Julian calender    */

    monthdays.2 = 28 + leap_year
    IF year = 1582 THEN monthdays.10 = 21       /* 1582: October had 10 days less */

    SELECT
       WHEN \DATATYPE(month,'N') THEN
            DO
               errmsg = ARG(1)||": month is not numeric"
               SIGNAL error
            END
       WHEN (month < 1) | (month > 12) THEN
            DO
               errmsg = ARG(1)||": month out of range"
               SIGNAL error
            END
       OTHERWISE
            month = month % 1   /* get rid of leading nulls */
    END

    SELECT
       WHEN \DATATYPE(day,'N') THEN
            DO
               errmsg = ARG(1)": day is not numeric"
               SIGNAL error
            END
       WHEN (day < 1) THEN
            DO
               errmsg = ARG(1)": day out of range"
               SIGNAL error
            END
       WHEN year = 1582 & month = 10 THEN    /* Gregorian: 1582, October 1-4, 15-31 */
            DO
               IF (day > 4 & day < 15) | day > 31 THEN
               DO
                  IF day > 31 THEN
                     errmsg = ARG(1)": too many days for given month"
                  ELSE
                     errmsg = ARG(1)": day out of range (1582/10/05-1582/10/14 do not exist)"
                  SIGNAL error
               END
            END
       WHEN day > monthdays.month THEN
            DO
               errmsg = ARG(1)": too many days for given month"
               SIGNAL error
            END
       OTHERWISE
            day = day % 1 /* get rid of leading nulls */
    END

    RETURN year month day
/* end of CHECK_DATE */


/* parse & check time, return 24hour-Time (military time) */
CHECK_TIME: PROCEDURE EXPOSE monthdays.
    PARSE UPPER ARG tmp
    time24 = 1                  /* starting with 24 hour time in mind */
    time12 = POS('M', tmp)      /* AM or PM ? */
    IF time12 > 0 THEN
    DO
      time24 = 0                /* 12 hour time in hand */
      letter = SUBSTR(tmp, time12 - 1, 1)
      IF \((letter = 'A') | letter = 'P') THEN
      DO
         errmsg = ARG(1)': not a valid AM/PM-time'
         SIGNAL error
      END
      tmp = SUBSTR(tmp, 1, time12 - 2)  /* remove ?M */
    END

    PARSE VAR tmp hours ':' minutes ':' seconds

    SELECT
      WHEN hours = '' THEN hours = 0
      WHEN \datatype(hours,'N') THEN     /* no numeric type */
           DO
              errmsg = ARG(1)": hours are not numeric"
              SIGNAL error
           END
      WHEN (hours < 0) | (hours > 23) THEN      /* out of range    */
           DO
              errmsg = ARG(1)": hours out of range"
              SIGNAL error
           END
      OTHERWISE NOP
    END

    SELECT
      WHEN minutes = '' THEN minutes = 0
      WHEN \datatype(minutes,'N') THEN     /* no numeric type */
           DO
              errmsg = ARG(1)": minutes are not numeric"
              SIGNAL error
           END
      WHEN (minutes < 0) | (minutes > 59) THEN /* out of range    */
           DO
              errmsg = ARG(1)": minutes out of range"
              SIGNAL error
           END
      OTHERWISE NOP
    END

    SELECT
      WHEN seconds = '' THEN seconds = 0
      WHEN \datatype(seconds,'N') THEN     /* no numeric type */
           DO
              errmsg = ARG(1)": seconds are not numeric"
              SIGNAL error
           END
      WHEN (seconds < 0) | (seconds >= 60) THEN /* out of range    */
           DO
              errmsg = ARG(1)": seconds out of range"
              SIGNAL error
           END
      OTHERWISE NOP
    END

    IF \time24 THEN             /* received a 12hour time, adjust it to 24hour time */
    DO
       IF (letter = 'A') & (hours = 12) THEN hours = 0
       ELSE IF ((letter = 'P') & (hours < 12)) THEN hours = hours + 12
    END

    RETURN hours  minutes seconds
/* end of CHECK_TIME */



/* calculate days based on 0000/01/01 (= 1. day == 1) */
DATE2DAYS: PROCEDURE  EXPOSE monthdays.
    PARSE ARG year month day

    days_1    = year * 365
    leap_days = year % 4

    IF year > 0 THEN
    DO
       leap_days = leap_days + 1        /* account for leap year in 0000 */

       IF year > 1582 THEN days_1 = days_1 - 10 /* account for 1582, which had 10 days less */

       IF year > 1600 THEN         /* account for Gregorian calender */
       DO
           diff = year - 1600
           leap_days = leap_days - (diff % 100 - diff % 400)
           leap_year = (((diff // 4) = 0) & \((diff // 100) = 0)) | ((diff // 400)=0) /* leap year in hand ? */
       END
       ELSE leap_year = ((year // 4) = 0)       /* leap year in hand ? */

       leap_days = leap_days - leap_year
    END

    days_2 = SUBSTR(date2julian(ARG(1)), 5, 3)

    RETURN (days_1 + leap_days + days_2)
/* end of DATE2DAYS */


DAYS2DATE: PROCEDURE  EXPOSE monthdays. /* calculate sorted day from given days */
    days = ARG(1)

    avg_days = 365.25        /* average days a year */

    /* estimate years */
    IF days > 578181 THEN               /* year greater than 1582/12/31 ? */
       year1 = (days + 10 ) % avg_days  /* account for 10 missing days in 1582 */
    ELSE
       year1 = days % avg_days


    DO FOREVER

       /* is year1 a leap year ? */
       IF year1 > 1582 THEN                     /* Gregorian calender */
          year_days = (((year1 // 4) = 0) & \((year1 // 100) = 0)) | ((year1 // 400)=0)
       ELSE year_days = ((year1 // 4) = 0)      /* Julian calender    */

       IF year1 <> 1582 THEN year_days = year_days + 365
       ELSE year_days = 355             /* 1582 had 10 days less */

       days_year1 = date2days(year1 "1 1")   /* pad year with 0 */
       diff1 = days - days_year1

       IF diff1 < 0 THEN year1 = year1 - 1
       ELSE IF diff1 > (year_days - 1) THEN year1 = year1 + 1
       ELSE LEAVE
    END
    diff1 = diff1 + 1           /* one day off, due to subtraction */

    tmp = RIGHT(year1,4,'0')|| RIGHT(diff1,3,'0')       /* build Julian date */

    RETURN julian2date(tmp)     /* build sorted day */
/* end of DAYS2DATE */




/* calculate decimal fraction from time */
TIME2FRACT: PROCEDURE  EXPOSE monthdays.     /* calculate decimal value for time */
    PARSE ARG hours minutes seconds

    /* hour_div = 24      =   24           */
    /* min_div  = 1440    =   24 * 60      */
    /* sec_div  = 86400   =   24 * 60 * 60 */

    RETURN ((hours/24) + (minutes/1440) + (seconds/86400))
/* end of TIME2FRACT */


/* calculate time from fraction */
FRACT2TIME: PROCEDURE  EXPOSE monthdays.     /* calculate time from given value */
    /* hours    = 24      =   24           */
    /* minutes  = 1440    =   24 * 60      */
    /* seconds  = 86400   =   24 * 60 * 60 */

    tmp = arg(1) + 0.0000001            /* account for possible precision error */

    hours   = (tmp * 24) % 1
    minutes = (tmp * 1440 - hours * 60) % 1
    seconds = (tmp * 86400 - hours * 3600 - minutes * 60) % 1

    RETURN RIGHT(hours,2,'0')':'RIGHT(minutes,2,'0')':'RIGHT(seconds,2,'0')

/* end of FRACT2TIME */


/* build Julian date from sorted date, result: yyyyddd */
DATE2JULIAN: PROCEDURE EXPOSE monthdays.
    PARSE ARG year month day

    /* is year a leap year ? */
    IF year > 1582 THEN                 /* Gregorian calender */
       leap_year = (((year // 4) = 0) & \((year // 100) = 0)) | ((year // 400)=0)
    ELSE leap_year = (year // 4) = 0    /* Julian calender    */

    monthdays.2 = 28 + leap_year
    IF year = 1582 THEN monthdays.10 = 21       /* 1582: October just had 21 days */

    result_function = 0
    DO i = 1 TO month - 1
       result_function = result_function + monthdays.i
    END

    IF year = 1582 & month = 10 & day > 4 THEN day = day - 10       /* Gregorian: 10 days too many */
    result_function = result_function + day

    RETURN year||RIGHT(result_function,3,'0')
/* end of DATE2JULIAN */




/* build sorted date from Julian date, result: yyyymmdd */
JULIAN2DATE: PROCEDURE EXPOSE monthdays.
    year = SUBSTR(ARG(1),1,4)

    /* is year a leap year ? */
    IF year > 1582 THEN                 /* Gregorian calender */
       leap_year = (((year // 4) = 0) & \((year // 100) = 0)) | ((year // 400)=0)
    ELSE leap_year = (year // 4) = 0    /* Julian calender    */

    monthdays.2 = 28 + leap_year
    IF year = 1582 THEN monthdays.10 = 21       /* 1582: October just had 21 days */

    jul_days = SUBSTR(ARG(1),5)       /* Julian days */
    SELECT
       WHEN jul_days > (365 + leap_year) THEN
          DO
             errmsg = ARG(1)": too many days for the given year"
             SIGNAL error
          END
       WHEN year = 1582 & jul_days > 355 THEN       /* 1582: 10 days less than other years */
          DO
             errmsg = ARG(1)": too many days for 1582 (had 355 days only)"
             SIGNAL error
          END
       OTHERWISE NOP
    END

    /* calculate days */
    tmp = 0
    DO month = 1 TO 12
       tmp = tmp + monthdays.month
       IF tmp = jul_days THEN        /* exactly given days ?       */
       DO
          day = monthdays.month
          LEAVE
       END

       IF tmp > jul_days THEN      /* got over month              */
       DO
          day = monthdays.month - (tmp - jul_days)
          LEAVE
       END
    END

    /* 1582: October 1-4, 15-31,  adjust for 10 missing days if necessary */
    IF year = 1582 & month = 10 & day > 4 THEN day = day + 10

    RETURN year||RIGHT(month,2,'0')||RIGHT(day,2,'0')
/* end of JULIAN2DATE */




/* return day of sorted date as name or as index */
WEEKDAY: PROCEDURE EXPOSE monthdays.
    total_days = date2days(ARG(1))
    dayindex = (total_days + 2) // 7 + 1  /* normalize on Mondays = 1, ..., Sunday = 7 */

    IF ARG(2) = 'I' THEN result_function = dayindex
    ELSE IF ARG(2) = 'ALL' THEN result_function = total_days dayindex
    ELSE result_function = WORD("Monday Tuesday Wednesday Thursday Friday Saturday Sunday", dayindex)

    RETURN result_function
    /* remark:
        According to an advice of ISO a week starts with MONDAY, hence:
        Monday = 1, Tuesday = 2, Wednesday = 3, Thursday = 4, Friday = 5,
        Saturday = 6, Sunday = 7.
        The German DIN-organization already normalized on the ISO advice.
    */
/* end of WEEKDAY */



foo1:
say 'Content-type: text/plain '
say
say "error in mkcustcg script, at line " sigl " code= " rc
say
exit 0
